# This (sub-)makefile is part of the Classic McEliece hardware source code.
# 
# Copyright (C) 2022
#
# Authors: Norman Lahr <norman@lahr.email>
# 
# This source code is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
# 
# This source code is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
# details.
# 
# You should have received a copy of the GNU General Public License along with
# this source code. If not, see <https://www.gnu.org/licenses/>. 

XILINX_MODELS = \
	artix7_200t \
	artix7_100t \
	artix7_35t

define XILINX_MODELS_TEMPLATE =

ifeq ($(1), artix7_200t)
	XILINX_FPGA_MODEL_$(1) = $(1)
	XILINX_FPGA_MODEL_ID_$(1) = xc7a200tfbg484-1
	XILINX_FPGA_MODEL_FREQ_$(1) = 100
endif

ifeq ($(1), artix7_100t)
	XILINX_FPGA_MODEL_$(1) = $(1)
	XILINX_FPGA_MODEL_ID_$(1) = xc7a100tcsg324-1
	XILINX_FPGA_MODEL_FREQ_$(1) = 400
endif

ifeq ($(1), artix7_35t)
	XILINX_FPGA_MODEL_$(1) = $(1)
	XILINX_FPGA_MODEL_ID_$(1) = xc7a35ticsg324-1l
	XILINX_FPGA_MODEL_FREQ_$(1) = 400
endif

endef

# Define all parameters globally
$(foreach model, $(XILINX_MODELS), $(eval $(call XILINX_MODELS_TEMPLATE,$(model))))
