Systemizers
===========

This directory provides the following versions of the systemizer:

- single\_pass\_GF2:
  Original GF(2) systemizer from the 2016 paper [1].

- single\_pass\_GF2\_redo:
  Integration of the ideas from the 2022 paper [3] into single\_pass\_GF2.

- single\_pass\_GFx:
  Multi-field version of the single\_pass\_GF2 systemizer from the 2017 paper [2].

- single\_pass\_GFx\_abort:
  Adapted version of single\_pass\_GFx supporting early abort.

- single\_pass\_early\_abort\_redo:
  Re-implementation of single\_pass\_early\_abort from the paper [3] based on single\_pass\_GF2\_redo and the 2016 paper [1].


[1] Wen Wang, Jakub Szefer, and Ruben Niederhagen: "Solving Large Systems of Linear Equations over GF(2) on FPGAs". Reconfigurable Computing and FPGAs — ReConFig 2016, IEEE, 2016.

[2] Wen Wang, Jakub Szefer, and Ruben Niederhagen: "FPGA-based Key Generator for the Niederreiter Cryptosystem Using Binary Goppa Codes". Cryptographic Hardware and Embedded Systems — CHES 2017, Lecture Notes in Computer Science, Vol. 10529, pp. 253—274. Springer, 2017.

[3] Po-Jen Chen, Tung Chou, Sanjay Deshpande, Norman Lahr, Ruben Niederhagen, Jakub Szefer, and Wen Wang: "Complete and Improved FPGA Implementation of Classic McEliece". IACR Transactions on Cryptographic Hardware and Embedded Systems — TCHES 2022(3), pp. 71—113, 2022.


single\_pass\_early\_abort\_redo
--------------------------------

This variant re-implements and improves uppon the variant single\_pass\_early\_abort from the 2022 paper [3]:

- The multiplexer MMUX1 is avoided by having the processor array issue all instructions, including those generated by control logic.
- All steps of each phase are interleaved (while in the 2022 design the pivoting step is not interleaved with the other steps of the corresponding phase).
- Operations are stored in data memory by using a dual-bank quad-port memory with all independent two write and two read ports. One bank stores even addresses and the other bank stores odd addresses such that the corresponding write address selects either bank one or bank two. Memory access in the sysmteizer is scheduled such that operations and data are always read and written alternatingly from odd and even addresses.
  This removes the need to transfer operations between data memory to an instruction memory as in the 2022 version.
- Counter values for generating swap operatations are stored in data memory as well (at the end of the memory, behind the matrix data). Counter values are stored transposed - one address stores all 1st bits, the next all 2nd bits and so on. Counters are read and restored using bitwise shifts. Additional cycles are required between phases for storing and restoring counter values.

The new design requires less memory blocks and no DSPs but slighlty more slices and runs at a higher frequency compard to the old design.

The same approach can be used for hybrid\_early\_abort and dual\_pass\_early\_abort.

