#!/usr/bin/sage

#
# This file is part of the testbench, which generates a random input polynomial.
# 
# Copyright (C) 2018
# Authors: Wen Wang <wen.wang.ww349@yale.edu>
#          Ruben Niederhagen <ruben@polycephaly.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import sys

N = int(sys.argv[1])
K = int(sys.argv[2])
m = int(sys.argv[3])

fmt = "{0:0" + str(m) + "b}"

F.<x> = GF(2)[]
KK.<a> = GF(2^m, modulus="first_lexicographic")
 
set_random_seed(1)

block = KK.random_element()
while (block.integer_representation() >= (K/N-1)):
  block = KK.random_element()
sys.stdout.write(fmt.format(block.integer_representation()))
sys.stdout.write("\n")

for i in range(N):
  index = KK.random_element()
  sys.stdout.write(fmt.format(index.integer_representation()))
  

sys.stdout.write("\n")


for i in range(N):
  eva_inv = KK.random_element()
  sys.stdout.write(fmt.format(eva_inv.integer_representation()))
  
sys.stdout.write("\n")

 
 

