# This (sub-)makefile is part of the Classic McEliece hardware source code.
# 
# Copyright (C) 2022
#
# Authors: Norman Lahr <norman@lahr.email>
# 
# This source code is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
# 
# This source code is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
# details.
# 
# You should have received a copy of the GNU General Public License along with
# this source code. If not, see <https://www.gnu.org/licenses/>. 

INV_G_ALPHA_SRC_PATH := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))

INV_G_ALPHA_SUBMODULES := LOG2 MEMORY_DUAL GF_INV POINT_LOCATOR

include $(COMMON_SRC_PATH)/math/module.mk
include $(COMMON_SRC_PATH)/memory/module.mk
include $(COMMON_SRC_PATH)/point_locator/module.mk

INV_G_ALPHA_SRC = inv_g_alpha.v

INV_G_ALPHA_SRC += $(foreach module,$(INV_G_ALPHA_SUBMODULES),$($(module)_SRC))

INV_G_ALPHA =

inv_g_alpha: $(INV_G_ALPHA)

# Specify targets for each parameter set
define INV_G_ALPHA_SRC_TEMPLATE =

# Define all required targets to be included in the modules above
INV_G_ALPHA_$(1) = $(addprefix $$(BUILD_DIR_SRC_$(1))/,$$(INV_G_ALPHA_SRC))

# Collect all targets
INV_G_ALPHA += INV_G_ALPHA_$(1)

$$(BUILD_DIR_SRC_$(1))/inv_g_alpha.v: $$(INV_G_ALPHA_SRC_PATH)/inv_g_alpha.v
	cp $$< $$@

endef

$(foreach par, $(PAR_SETS), $(eval $(call INV_G_ALPHA_SRC_TEMPLATE,$(par))))
