#!/usr/bin/sage

#
# function: generate the theoretical result.
# 
# Copyright (C) 2018
# Authors: Wen Wang <wen.wang.ww349@yale.edu>
#          Ruben Niederhagen <ruben@polycephaly.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import sys

N = int(sys.argv[1])
m = int(sys.argv[2])
mem_WIDTH = int(sys.argv[6])
 
n = 2^m
 
fmt = "{0:0" + str(m) + "b}"

F.<x> = GF(2)[]
KK.<a> = GF(2^m, modulus="first_lexicographic")

with open(sys.argv[3], "r") as f:
  lines = f.readlines()

block = lines[0]

# block number, in int 
block = int(block[:m], 2)
 
# P list, in int
index = []
with open(sys.argv[4], "r") as f:
  for line in f:
    index.append(int(line[:m], 2))
 
# poly evaluation result list, in KK
eva = []
with open(sys.argv[5], "r") as f:
  for line in f:
    while len(line) > 1:
      eva.append(KK.fetch_int(int(line[:m], 2)))
      line = line[m:]
 
# inversion result, in KK
eva_inv = []
for i in range(n):
  a = int(i/mem_WIDTH)
  b = i % mem_WIDTH
  c = mem_WIDTH*a+(mem_WIDTH-1-b)
  eva_inv.append((eva[c])^-1)
  
# write N index out
index_list = []
for i in reversed(range(N*block, N*block+N, 1)):
  sys.stdout.write(fmt.format(index[i]))
  index_list.append(index[i])
sys.stdout.write("\n")

for i in (range(N)):
  k = index_list[i]
  sys.stdout.write(fmt.format(eva_inv[k].integer_representation()))
sys.stdout.write("\n")


 
  
