# This (sub-)makefile is part of the Classic McEliece hardware source code.
# 
# Copyright (C) 2022
#
# Authors: Norman Lahr <norman@lahr.email>
# 
# This source code is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
# 
# This source code is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
# details.
# 
# You should have received a copy of the GNU General Public License along with
# this source code. If not, see <https://www.gnu.org/licenses/>. 

GEN_PK_SRC_PATH := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))

SYSTEMIZER ?= SYSTEMIZER_SPEA_REDO

GEN_PK_SUBMODULES := GEN_H $(SYSTEMIZER)

include $(GEN_PK_SRC_PATH)/gen_H/module.mk
include $(COMMON_SRC_PATH)/systemizer/modules.mk

GEN_PK_SRC = gen_pk.v

GEN_PK_SRC += $(foreach module,$(GEN_PK_SUBMODULES),$($(module)_SRC))

GEN_PK =

gen_pk: $(GEN_PK)

# Specify targets for each parameter set
define GEN_PK_SRC_TEMPLATE =

# Define all required targets to be included in the modules above
GEN_PK_$(1) = $(addprefix $$(BUILD_DIR_SRC_$(1))/,$$(GEN_PK_SRC))

# Collect all targets
GEN_PK += GEN_PK_$(1)

$$(BUILD_DIR_SRC_$(1))/gen_pk.v: $$(GEN_PK_SRC_PATH)/gen_pk.v
	cp $$< $$@

endef

$(foreach par, $(PAR_SETS), $(eval $(call GEN_PK_SRC_TEMPLATE,$(par))))
