#!/usr/bin/sage

#
# This file is part of the testbench, which generates random coefficients.
# 
# Copyright (C) 2018
# Authors: Wen Wang <wen.wang.ww349@yale.edu>
#          Ruben Niederhagen <ruben@polycephaly.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import sys

N = int(sys.argv[1])
L = int(sys.argv[2])
K = int(sys.argv[3])
m = int(sys.argv[4])

L = L  
K = K  

F.<x> = GF(2)[]
KK.<a> = GF(2^m, modulus="first_lexicographic")

g = PolynomialRing(GF(2), 'x').irreducible_element(L, algorithm="first_lexicographic")

Kx = KK.extension(g)

run = True

M = matrix(KK, L, K)

set_random_seed(1)

while run:
  r = Kx.random_element()
  ri = Kx.one()
  for i in range(K):
    for j in range(L):
      M[j, i] = ri[j]
    ri *= r

  E = M.echelon_form()

  run = False

  for i in range(len(E.rows())):
    if E[i,i] == 0:
       run = True

fmt = "{0:0" + str(m) + "b}"

#print g

for i in range(L):
#  r = (r*r).mod(g)
  ri = r[L-1-i]
  sys.stdout.write(fmt.format(ri.integer_representation()))
#  sys.stdout.write("\n")

#sys.stdout.write("\n")
       

