#!/usr/bin/sage

#
# This file is part of the testbench, which generates theoretical results.
# 
# Copyright (C) 2018
# Authors: Wen Wang <wen.wang.ww349@yale.edu>
#          Ruben Niederhagen <ruben@polycephaly.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import sys

N = int(sys.argv[1])
L = int(sys.argv[2])
K = int(sys.argv[3])
m = int(sys.argv[4])

K_ceil = N*int((N+K-1)/N)

F.<x> = GF(2)[]
KK.<a> = GF(2^m, modulus="first_lexicographic")

g = PolynomialRing(GF(2), 'x').irreducible_element(L, algorithm="first_lexicographic")

Kx = KK.extension(g)

coeff_in = sys.stdin.readline().strip()

coeff = []

while coeff_in != "":
  coeff.append(Kx(KK.fetch_int(int(coeff_in[:m],2))))
  coeff_in = coeff_in[m:]

r = Kx.zero()

for i,v in enumerate(reversed(coeff)):
  r += x^i*v

#print r

for i in range(int(K_ceil/N)):
  for j in range(L):
    for k in reversed(range(N)):
      degree = N*i+k
      poly = r^degree
      element = ("{0:0%db}" %m).format(poly[j].integer_representation())
      sys.stdout.write(element)
    sys.stdout.write("\n")
#  print poly
       

